"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const url_1 = __importDefault(require("url"));
function respondWithJson(req, content) {
    req.respond({
        headers: {
            'Access-Control-Allow-Origin': '*',
            'Content-Type': 'application/octet-stream'
        },
        body: JSON.stringify(content)
    });
}
function interceptRequests(page, responseMap) {
    return __awaiter(this, void 0, void 0, function* () {
        yield page.setRequestInterception(true);
        page.on('request', request => {
            const { hostname } = url_1.default.parse(request.url().toString());
            const mockedResponse = responseMap[hostname];
            if (mockedResponse) {
                respondWithJson(request, mockedResponse);
                return;
            }
            request.continue();
        });
    });
}
exports.interceptRequests = interceptRequests;
//# sourceMappingURL=request-interception.js.map